# coding: utf-8

"""
    TrueLayer Resource API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v1.0
    Contact: rienafairefr@gmail.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

import marshmallow
from marshmallow import Schema, validates, ValidationError, post_load, missing

import truelayer
import truelayer.fields
from truelayer.configuration import Configuration



class AccountSchema(Schema):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    account_id = marshmallow.fields.String()

    account_number = truelayer.fields.Nested('AccountNumber')('AccountNumberSchema', )

    account_type = marshmallow.fields.String()

    currency = marshmallow.fields.String()

    description = marshmallow.fields.String()

    display_name = marshmallow.fields.String()

    provider = truelayer.fields.Nested('ProviderInfo')('ProviderInfoSchema', )

    update_timestamp = truelayer.fields.DateTime()

    @validates("account_id")
    def validates_account_id(self, account_id):
        pass

    @validates("account_number")
    def validates_account_number(self, account_number):
        pass

    @validates("account_type")
    def validates_account_type(self, account_type):
        pass

    @validates("currency")
    def validates_currency(self, currency):
        pass

    @validates("description")
    def validates_description(self, description):
        pass

    @validates("display_name")
    def validates_display_name(self, display_name):
        pass

    @validates("provider")
    def validates_provider(self, provider):
        pass

    @validates("update_timestamp")
    def validates_update_timestamp(self, update_timestamp):
        pass

    @post_load
    def post_load(self, data, **kwargs):
        config = Configuration()
        config.client_side_validation = False
        return Account(local_vars_configuration=config, **data)


class Account(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'str',
        'account_number': 'AccountNumber',
        'account_type': 'str',
        'currency': 'str',
        'description': 'str',
        'display_name': 'str',
        'provider': 'ProviderInfo',
        'update_timestamp': 'datetime'
    }

    attribute_map = {
        'account_id': 'account_id',
        'account_number': 'account_number',
        'account_type': 'account_type',
        'currency': 'currency',
        'description': 'description',
        'display_name': 'display_name',
        'provider': 'provider',
        'update_timestamp': 'update_timestamp'
    }

    def __init__(self, account_id=missing, account_number=missing, account_type=missing, currency=missing, description=missing, display_name=missing, provider=missing, update_timestamp=missing, local_vars_configuration=None):  # noqa: E501
        """Account - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.discriminator = None
        if self.local_vars_configuration.client_side_validation:
            validated = AccountSchema().load({
                'account_id': account_id,
                'account_number': account_number,
                'account_type': account_type,
                'currency': currency,
                'description': description,
                'display_name': display_name,
                'provider': provider,
                'update_timestamp': update_timestamp
            })
            self.account_id = validated.account_id
            self.account_number = validated.account_number
            self.account_type = validated.account_type
            self.currency = validated.currency
            self.description = validated.description
            self.display_name = validated.display_name
            self.provider = validated.provider
            self.update_timestamp = validated.update_timestamp
        else:
            self.account_id = account_id
            self.account_number = account_number
            self.account_type = account_type
            self.currency = currency
            self.description = description
            self.display_name = display_name
            self.provider = provider
            self.update_timestamp = update_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        return AccountSchema().dump(self)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Account):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Account):
            return True

        return self.to_dict() != other.to_dict()
