# coding: utf-8

"""
    TrueLayer Resource API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v1.0
    Contact: rienafairefr@gmail.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

import marshmallow
from marshmallow import Schema, validates, ValidationError, post_load, missing

import truelayer
import truelayer.fields
from truelayer.configuration import Configuration



class CachedAPIResponseObjectSchema(Schema):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    error = marshmallow.fields.String()

    error_description = marshmallow.fields.String()

    error_details = marshmallow.fields.Dict(keys=marshmallow.fields.String(), values=marshmallow.fields.String()
,)

    results = marshmallow.fields.List(marshmallow.fields.Dict(keys=marshmallow.fields.String(), values=marshmallow.fields.String()
,)
,)

    results_uri = marshmallow.fields.String()

    status = marshmallow.fields.String()

    task_id = marshmallow.fields.String()

    @validates("error")
    def validates_error(self, error):
        pass

    @validates("error_description")
    def validates_error_description(self, error_description):
        pass

    @validates("error_details")
    def validates_error_details(self, error_details):
        pass

    @validates("results")
    def validates_results(self, results):
        pass

    @validates("results_uri")
    def validates_results_uri(self, results_uri):
        pass

    @validates("status")
    def validates_status(self, status):
        allowed_values = ["Queued", "Running", "Succeeded", "Failed"]  # noqa: E501
        if status not in allowed_values:  # noqa: E501
            raise ValidationError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )
        pass

    @validates("task_id")
    def validates_task_id(self, task_id):
        pass

    @post_load
    def post_load(self, data, **kwargs):
        config = Configuration()
        config.client_side_validation = False
        return CachedAPIResponseObject(local_vars_configuration=config, **data)


class CachedAPIResponseObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'error': 'str',
        'error_description': 'str',
        'error_details': 'dict(str, str)',
        'results': 'list[dict(str, str)]',
        'results_uri': 'str',
        'status': 'str',
        'task_id': 'str'
    }

    attribute_map = {
        'error': 'error',
        'error_description': 'error_description',
        'error_details': 'error_details',
        'results': 'results',
        'results_uri': 'results_uri',
        'status': 'status',
        'task_id': 'task_id'
    }

    def __init__(self, error=missing, error_description=missing, error_details=missing, results=missing, results_uri=missing, status=missing, task_id=missing, local_vars_configuration=None):  # noqa: E501
        """CachedAPIResponseObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.discriminator = None
        if self.local_vars_configuration.client_side_validation:
            validated = CachedAPIResponseObjectSchema().load({
                'error': error,
                'error_description': error_description,
                'error_details': error_details,
                'results': results,
                'results_uri': results_uri,
                'status': status,
                'task_id': task_id
            })
            self.error = validated.error
            self.error_description = validated.error_description
            self.error_details = validated.error_details
            self.results = validated.results
            self.results_uri = validated.results_uri
            self.status = validated.status
            self.task_id = validated.task_id
        else:
            self.error = error
            self.error_description = error_description
            self.error_details = error_details
            self.results = results
            self.results_uri = results_uri
            self.status = status
            self.task_id = task_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        return CachedAPIResponseObjectSchema().dump(self)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CachedAPIResponseObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CachedAPIResponseObject):
            return True

        return self.to_dict() != other.to_dict()
